#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum FileOutputFormat {
    #[serde(rename = "PARQUET")]
    Parquet,
    #[serde(rename = "CSV")]
    Csv,
    #[serde(rename = "PARQUET_TAR")]
    ParquetTar,
    #[serde(rename = "AVRO_STREAM")]
    AvroStream,
    #[serde(rename = "JSON_L")]
    JsonL,
    #[serde(rename = "MANIFEST")]
    Manifest,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl FileOutputFormat {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            FileOutputFormat::Parquet => "PARQUET",
            FileOutputFormat::Csv => "CSV",
            FileOutputFormat::ParquetTar => "PARQUET_TAR",
            FileOutputFormat::AvroStream => "AVRO_STREAM",
            FileOutputFormat::JsonL => "JSON_L",
            FileOutputFormat::Manifest => "MANIFEST",
            FileOutputFormat::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for FileOutputFormat {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for FileOutputFormat {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for FileOutputFormat {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<FileOutputFormat, conjure_object::plain::ParseEnumError> {
        match v {
            "PARQUET" => Ok(FileOutputFormat::Parquet),
            "CSV" => Ok(FileOutputFormat::Csv),
            "PARQUET_TAR" => Ok(FileOutputFormat::ParquetTar),
            "AVRO_STREAM" => Ok(FileOutputFormat::AvroStream),
            "JSON_L" => Ok(FileOutputFormat::JsonL),
            "MANIFEST" => Ok(FileOutputFormat::Manifest),
            v => v.parse().map(|v| FileOutputFormat::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for FileOutputFormat {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<FileOutputFormat, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the FileOutputFormat enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
